/* Custom DMS Script */
$(document).ready(function () {

  //MODAL: stop video on closing modal
  $('.dms-modal').on('hidden.bs.modal', function () {
    var iframeSrc = $('iframe').attr('src');
    $('iframe').attr('src', '');
    $('iframe').attr('src', iframeSrc);
  })

  /* MENU: to add class active to menu */
  let linkPageGroup = document.querySelectorAll('a.list-group-item');
  let linkPage = window.location.pathname
  linkPageGroup.forEach(el => {

    if (linkPage.indexOf(el.getAttribute('href')) > -1) {
      el.classList.add('active')
    }
  });

  /* MENU: to activate */
  $("#menu-toggle").click(function (e) {
    e.preventDefault();
    $("#wrapper").toggleClass("toggled");
  });

  /* COPY OPTION SNIPPET */
  $(document.body).on('click', '.btn-copy-code', function (event) {
    $(event.target).closest('.btn-copy-code').blur();
  });

  function setAttributes(el, attrs) {
    for (var key in attrs) {
      el.setAttribute(key, attrs[key]);
    }
  }

  function removeAttributes(el, attrs) {
    for (var key in attrs) {
      el.removeAttribute(key, attrs[key]);
    }
  }

  let btnSnipet = document.querySelectorAll('.btn-copy-code');
  btnSnipet.forEach(element => {
    element.addEventListener('click', () => {

      navigator.clipboard.writeText(element.parentElement.parentElement.querySelector('.dms-snippet--code').textContent)
        .then(() => {
          setAttributes(element, {
            "title": "Copiato!",
            "data-toggle": "tooltip",
            "data-placement": "top"
          });
          console.log('Text copied.');
          $(element).tooltip("show");
        })
        .catch(() => {
          console.log('Failed to copy text.');
        });
    })

    element.addEventListener('mouseleave', () => {
      $(element).tooltip("dispose");
    })

  });

  /* MENU: navigation responsive menu */
  $(window).scroll(function () {
    if ($(this).scrollTop() > 257) {
      $('.open-menu').addClass('mobile-fixed');
      $('.dms-header--level-2').removeClass('has-margin-bottom');
    } else {
      $('.open-menu').removeClass('mobile-fixed');
      $('.dms-header--level-2').addClass('has-margin-bottom');
    }
  });

  $('.open-menu').click(function (e) {
    e.preventDefault();
    $('.dms-menu--navigation').addClass("is-open");
    $('body').addClass("menu-is-open");
  });

  $(".close-menu").click(function (e) {
    e.preventDefault();
    $('.dms-menu--navigation').removeClass("is-open");
    $('body').removeClass("menu-is-open");
  });

  /* TOOLTIP: init*/
  $('[data-toggle="tooltip"]').not(".btn-copy").tooltip();

  /* CAROUSEL: init */
  var slickCarouselItem = $('#dms-slick-carousel-1');
  if (slickCarouselItem.length > 0) {
    slickCarouselItem.slick({
      slidesToShow: 1,
      slidesToScroll: 1,
      draggable: true,
      dots: true,
      infinite: true,
      autoplay: true,
      autoplaySpeed: 3000,
      responsive: [{
        breakpoint: 992,
        settings: {
          arrows: false,
        }
      }]
    });
  }

  $('.dms-carousel.controller').find('.slick-dots').append("<li><button class='pause'><i class='dms-wk-icon-pause'></i></button><button class='play'><i class='dms-wk-icon-play'></i></button></li>");

  $('.pause').on('click', function () {
    $('#dms-slick-carousel-1')
      .slick('slickPause');
    $(".slick-dots").addClass("play-control").removeClass("stop-control");
  });

  $('.play').on('click', function () {
    $('#dms-slick-carousel-1')
      .slick('slickPlay');
    $(".slick-dots").removeClass("play-control").addClass("stop-control");
  });

  var slickCarouselItem2 = $('#dms-slick-carousel-2');
  if (slickCarouselItem2.length > 0) {
    slickCarouselItem2.slick({
      arrows: true,
      dots: true,
      infinite: true,
      speed: 300,
      slidesToShow: 3,
      slidesToScroll: 1,
      responsive: [{
          breakpoint: 1024,
          settings: {
            slidesToShow: 2,
            slidesToScroll: 1,
          }
        },
        {
          breakpoint: 600,
          settings: {
            slidesToShow: 2,
            slidesToScroll: 1
          }
        },
        {
          breakpoint: 480,
          settings: {
            slidesToShow: 1,
            slidesToScroll: 1
          }
        }
      ]
    });
  }

  /* DATATABLE: init */
  var exampleTableId = $('#table_id');
  if (exampleTableId.length > 0) {
    $('#table_id').DataTable({
      "scrollX": true,
      "lengthMenu": [
        [10, 25, 50, 100],
        [10, 25, 50, 100]
      ],
      "columnDefs": [{
        "orderable": false,
        "targets": 0
      }],
      "order": [
        [1, 'asc']
      ],
      "fnDrawCallback": function () {
        if (Math.ceil((this.fnSettings().fnRecordsDisplay()) / this.fnSettings()._iDisplayLength) > 1) {
          $('.dataTables_paginate').show();
        } else {
          $('.dataTables_paginate').hide();
        }
      },
      "dom": '<"top"lf>rt<"bottom"i><"bottom"p><"clear">',
      "language": {
        "lengthMenu": "Visualizza _MENU_ elementi per pagina",
        "zeroRecords": "Nessun risultato",
        "info": "Pagina _PAGE_ di _PAGES_",
        "infoEmpty": "Nessun risultato disponibile",
        "infoFiltered": "(Filtrati per _MAX_ di risultati)",
        "search": "Cerca:",
        "paginate": {
          "first": "Prima",
          "last": "Ultima",
          "next": "<i class='dms-wk-icon-arrow-right'></i>",
          "previous": "<i class='dms-wk-icon-arrow-left'></i>"
        }
      }
    });
  };

  var exampleTableIdTotal = $('#example_total');
  if (exampleTableIdTotal.length > 0) {
    $('#example_total').DataTable({

      "footerCallback": function (row, data, start, end, display) {
        var api = this.api();
        nb_cols = api.columns().nodes().length;
        var j = 3;
        while (j < nb_cols) {
          var pageTotal = api
            .column(j, {
              page: 'current'
            })
            .data()
            .reduce(function (a, b) {
              return Number(a) + Number(b);
            }, 0);
          // Update footer
          $(api.column(j).footer()).html(pageTotal);
          j++;
        }
      },
      "dom": '<"top"lf>rt<"bottom"i><"bottom"p><"clear">',
      "language": {
        "lengthMenu": "Visualizza _MENU_ elementi per pagina",
        "zeroRecords": "Nessun risultato",
        "info": "Pagina _PAGE_ di _PAGES_",
        "infoEmpty": "Nessun risultato disponibile",
        "infoFiltered": "(Filtrati per _MAX_ di risultati)",
        "search": "Cerca:",
        "paginate": {
          "first": "Prima",
          "last": "Ultima",
          "next": "<i class='dms-wk-icon-arrow-right'></i>",
          "previous": "<i class='dms-wk-icon-arrow-left'></i>"
        }
      }

    });
  };

  /* resize font */
  var resize = new Array('html');
  resize = resize.join(',');

  //resets the font size when "reset" is clicked
  var resetFont = $(resize).css('font-size');
  $(".reset").click(function () {
    $(resize).css('font-size', resetFont);
  });

  //increases font size when "+" is clicked
  $(".increase").click(function () {
    var originalFontSize = $(resize).css('font-size');
    var originalFontNumber = parseFloat(originalFontSize, 10);
    var newFontSize = originalFontNumber + 0.2;
    $(resize).css('font-size', newFontSize);
    return false;
  });

  //decrease font size when "-" is clicked
  $(".decrease").click(function () {
    var originalFontSize = $(resize).css('font-size');
    var originalFontNumber = parseFloat(originalFontSize, 10);
    var newFontSize = originalFontNumber - 0.2;
    $(resize).css('font-size', newFontSize);
    return false;
  });

  /* POPOVER: init */
  var popover = $('.example[data-toggle="popover"]');
  if (popover.length > 0) {
    popover.popover();
  }

  /* DATEPICKER: general config */
  var pageHasDatePickerItems = document.getElementsByClassName("dms-timepicker");
  if (pageHasDatePickerItems.length > 0) {
    $.fn.datetimepicker.Constructor.Default = $.extend({}, $.fn.datetimepicker.Constructor.Default, {
      icons: {
        up: 'custom-icon dms-wk-icon-arrow-up',
        down: 'custom-icon dms-wk-icon-arrow-down',
        previous: 'custom-icon dms-wk-icon-arrow-left',
        next: 'custom-icon dms-wk-icon-arrow-right',
        clear: 'custom-icon dms-wk-icon-delete',
        close: 'custom-icon dms-wk-icon-close'
      },
      tooltips: {
        today: 'Vai a oggi',
        clear: 'Annulla selezione',
        close: 'Chiudi',
        selectMonth: 'Seleziona mese',
        prevMonth: 'Mese precedente',
        nextMonth: 'Mese successivo',
        selectYear: 'Seleziona anno',
        prevYear: 'Anno precedente',
        nextYear: 'Prossimo anno',
        selectDecade: 'Seleziona decade',
        prevDecade: 'Decade precedente',
        nextDecade: 'Prossima decade',
        prevCentury: 'Secolo precedente',
        nextCentury: 'Prossimo secolo',
        incrementHour: 'Incrementa ora',
        pickHour: 'Seleziona ora',
        decrementHour: 'Decrementa ora',
        incrementMinute: 'Incrementa minuti',
        pickMinute: 'Seleziona minuti',
        decrementMinute: 'Decrementa minuti',
        incrementSecond: 'Incrementa secondi',
        pickSecond: 'Seleziona secondi',
        decrementSecond: 'Decrementa secondi'
      },
      widgetPositioning: {
        horizontal: 'right'
      },
      locale: 'it'
    });
  }

  //DATEPICKER: date init
  var datepickerDate = $('#datepicker1');
  if (datepickerDate.length > 0) {
    datepickerDate.datetimepicker({
      format: 'L'
    });
  }

  //DATEPICKER: time init
  var datepickerTime = $('#time1');
  if (datepickerTime.length > 0) {
    datepickerTime.datetimepicker({
      format: 'LT',
    });
  }

  //DATEPICKER: month/year init
  var datepickerMonthYear = $('#datepicker-month-year');
  if (datepickerMonthYear.length > 0) {
    datepickerMonthYear.datetimepicker({
      viewMode: 'months',
      minViewMode: 'months',
      maxViewMode: 'years',
      startView: 'months',
      format: 'MM/YYYY'
    })
  }

  //FORM ESEMPIO 

  //DATEPICKER: data unica init
  var dateUnica = $('#data-unica');
  if (dateUnica.length > 0) {
    dateUnica.datetimepicker({
      format: 'L'
    });
  }

  //DATEPICKER: orario-unico init
  var orarioUnico = $('#orario-unico');
  if (orarioUnico.length > 0) {
    orarioUnico.datetimepicker({
      format: 'LT',
    });
  }

  //DATEPICKER: data inizio init
  var dataInizio = $('#data-inizio');
  if (dataInizio.length > 0) {
    dataInizio.datetimepicker({
      format: 'L'
    });
  }

  //DATEPICKER: data fine init
  var dataFine = $('#data-fine');
  if (dataFine.length > 0) {
    dataFine.datetimepicker({
      format: 'L'
    });
  }

  //DATEPICKER: orario-inizio init
  var orarioInizio = $('#orario-inizio');
  if (orarioInizio.length > 0) {
    orarioInizio.datetimepicker({
      format: 'LT',
    });
  }

  //DATEPICKER: orario-fine init
  var orarioFine = $('#orario-fine');
  if (orarioFine.length > 0) {
    orarioFine.datetimepicker({
      format: 'LT',
    });
  }

  /* RATING */
  $(".rating.rating-label input[type=radio]").on("click", function (t) {
    var e = $(this).val(),
      i = "stelle";
    1 == e && (i = "stella"),
      $(this)
      .closest(".rating-label")
      .find("legend span:not(.sr-only)")
      .text(e + " " + i);
  });


  /* COOKIEBAR */
  $('.cookiebar-confirm').on('click', function () {
    $('.dms-cookiebar').remove();
  });

  /* STEPPER */
  var $progressWizard = $('.dms-stepper'),
    $tab_active,
    $tab_nav_active,
    $btn_prev = $progressWizard.find('.prev-step'),
    $btn_next = $progressWizard.find('.next-step'),
    $btn_confirm = $progressWizard.find('.confirm-step');

  $btn_next.on('click', function () {
    $tab_nav_active = $progressWizard.find('.nav-item.active');
    $tab_active = $progressWizard.find('.tab-pane.active');

    $tab_active.addClass('completed').removeClass('active');
    $tab_nav_active.addClass('completed').removeClass('active');

    $tab_nav_active.next().removeClass('disabled').addClass('active');
    $tab_active.next().removeClass('disabled').addClass('active');
  });

  $btn_prev.on('click', function () {
    $tab_nav_active = $progressWizard.find('.nav-item.active');
    $tab_active = $progressWizard.find('.tab-pane.active');

    $tab_active.removeClass('active').addClass('disabled').prev().removeClass('completed').addClass('active');
    $tab_nav_active.removeClass('active').addClass('disabled').prev().removeClass('completed').addClass('active');
  });

  $btn_confirm.on('click', function () {
    tab_nav_active = $progressWizard.find('.nav-item.active');
    $tab_active = $progressWizard.find('.tab-pane.active');

    $tab_active.addClass('completed');
    $tab_nav_active.addClass('completed');
  });


  // TAB

  $(".navigation-tab").on('click', function (e) {
    e.preventDefault();
    $(this).toggleClass("expanded");
    $(".dms-tab").toggleClass("tab-show");
  });

  $(".dms--nav-link").on('click', function (e) {
    e.preventDefault();
    $(".dms-tab").removeClass("tab-show");
  });


  $(".navigation-tab-vertical").on('click', function (e) {
    e.preventDefault();
    $(this).toggleClass("expanded");
    $(".nav-menu").toggleClass("tab-show");
  });

  $(".nav-link").on('click', function (e) {
    e.preventDefault();
    $(".nav-menu").removeClass("tab-show");
  });


  /* TOAST */

  //Close toast
  $('.dms-toast .close').on('click', function () {
    $(this).parents('.dms-toast').hide();
  });

  //Open toast into DS
  $('[data-toggle="toast"]').on('click', function() {
    
    //toast's type
    const info = 'dms-toast--info';
    const warning = 'dms-toast--warning';
    const error = 'dms-toast--error';
    const success = 'dms-toast--success';
    const currentToast = $(this).data('target');

    if (currentToast === success) {
      showHideToast(success);
    } else if (currentToast === warning) {
      showHideToast(warning);
    } else if (currentToast === error) {
      showHideToast(error);
    }
  });

  //To show and hide toast type
  function showHideToast(typeToast) {
    const typeSelectedToast = typeToast;
    $('.' + typeSelectedToast).fadeIn().delay(2000).fadeOut(500);
  }

});


/* VALIDATION FORM */
(function () {
  'use strict';
  window.addEventListener('load', function () {
    var forms = document.getElementsByClassName('needs-validation');
    var validation = Array.prototype.filter.call(forms, function (form) {
      form.addEventListener('submit', function (event) {
        if (form.checkValidity() === false) {
          event.preventDefault();
          event.stopPropagation();
        }
      }, false);
      form.classList.add('was-validated');
    });
  }, false);
})();